# CfnTrail

Creates a trail that specifies the settings for delivery of log data to an Amazon S3 bucket.

Extends: Construct › CfnElement › CfnRefElement › CfnResource › CfnTrail
Implements: IInspectable, ITaggable, IEnvironmentAware, ITrailRef, IConstruct, IDependable

- CloudFormation: [`AWS::CloudTrail::Trail`](https://docs.aws.amazon.com/AWSCloudFormation/latest/TemplateReference/aws-resource-cloudtrail-trail.html)
- Source: Generated code
- Type last changed: v2.252.0 · 30 Apr 2026

## Example

```ts
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_cloudtrail as cloudtrail } from 'aws-cdk-lib';
const cfnTrail = new cloudtrail.CfnTrail(this, 'MyCfnTrail', {
  isLogging: false,
  s3BucketName: 's3BucketName',

  // the properties below are optional
  advancedEventSelectors: [{
    fieldSelectors: [{
      field: 'field',

      // the properties below are optional
      endsWith: ['endsWith'],
      equalTo: ['equalTo'],
      notEndsWith: ['notEndsWith'],
      notEquals: ['notEquals'],
      notStartsWith: ['notStartsWith'],
      startsWith: ['startsWith'],
    }],

    // the properties below are optional
    name: 'name',
  }],
  aggregationConfigurations: [{
    eventCategory: 'eventCategory',
    templates: ['templates'],
  }],
  cloudWatchLogsLogGroupArn: 'cloudWatchLogsLogGroupArn',
  cloudWatchLogsRoleArn: 'cloudWatchLogsRoleArn',
  enableLogFileValidation: false,
  eventSelectors: [{
    dataResources: [{
      type: 'type',

      // the properties below are optional
      values: ['values'],
    }],
    excludeManagementEventSources: ['excludeManagementEventSources'],
    includeManagementEvents: false,
    readWriteType: 'readWriteType',
  }],
  includeGlobalServiceEvents: false,
  insightSelectors: [{
    eventCategories: ['eventCategories'],
    insightType: 'insightType',
  }],
  isMultiRegionTrail: false,
  isOrganizationTrail: false,
  kmsKeyId: 'kmsKeyId',
  s3KeyPrefix: 's3KeyPrefix',
  snsTopicName: 'snsTopicName',
  tags: [{
    key: 'key',
    value: 'value',
  }],
  trailName: 'trailName',
});
```

## Initializer

```ts
new CfnTrail(scope: Construct, id: string, props: CfnTrailProps)
```

## Construct Props

- `advancedEventSelectors`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnTrail.AdvancedEventSelectorProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_cloudtrail.CfnTrail.AdvancedEventSelectorProperty.html)[] — Specifies the settings for advanced event selectors.

  You can use advanced event selectors to log management events, data events for all resource types, and network activity events.

  You can add advanced event selectors, and conditions for your advanced event selectors, up to a maximum of 500 values for all conditions and selectors on a trail. You can use either `AdvancedEventSelectors` or `EventSelectors` , but not both. If you apply `AdvancedEventSelectors` to a trail, any existing `EventSelectors` are overwritten. For more information about advanced event selectors, see [Logging data events](https://docs.aws.amazon.com/awscloudtrail/latest/userguide/logging-data-events-with-cloudtrail.html) and [Logging network activity events](https://docs.aws.amazon.com/awscloudtrail/latest/userguide/logging-network-events-with-cloudtrail.html) in the *AWS CloudTrail User Guide* .

- `aggregationConfigurations`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnTrail.AggregationConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_cloudtrail.CfnTrail.AggregationConfigurationProperty.html)[] — Specifies the aggregation configuration to aggregate CloudTrail Events.

  A maximum of 1 aggregation configuration is allowed.

- `cloudWatchLogsLogGroupArn`: string | [ILogGroupRef](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_logs.ILogGroupRef.html) — Specifies a log group name using an Amazon Resource Name (ARN), a unique identifier that represents the log group to which CloudTrail logs are delivered.

  You must use a log group that exists in your account.

  To enable CloudWatch Logs delivery, you must provide values for `CloudWatchLogsLogGroupArn` and `CloudWatchLogsRoleArn` .

  > If you previously enabled CloudWatch Logs delivery and want to disable CloudWatch Logs delivery, you must set the values of the `CloudWatchLogsRoleArn` and `CloudWatchLogsLogGroupArn` fields to `""` .

- `cloudWatchLogsRoleArn`: string | [IRoleRef](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_iam.IRoleRef.html) — Specifies the role for the CloudWatch Logs endpoint to assume to write to a user's log group.

  You must use a role that exists in your account.

  To enable CloudWatch Logs delivery, you must provide values for `CloudWatchLogsLogGroupArn` and `CloudWatchLogsRoleArn` .

  > If you previously enabled CloudWatch Logs delivery and want to disable CloudWatch Logs delivery, you must set the values of the `CloudWatchLogsRoleArn` and `CloudWatchLogsLogGroupArn` fields to `""` .

- `enableLogFileValidation`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — Specifies whether log file validation is enabled. The default is false.

  > When you disable log file integrity validation, the chain of digest files is broken after one hour. CloudTrail does not create digest files for log files that were delivered during a period in which log file integrity validation was disabled. For example, if you enable log file integrity validation at noon on January 1, disable it at noon on January 2, and re-enable it at noon on January 10, digest files will not be created for the log files delivered from noon on January 2 to noon on January 10. The same applies whenever you stop CloudTrail logging or delete a trail.

- `eventSelectors`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnTrail.EventSelectorProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_cloudtrail.CfnTrail.EventSelectorProperty.html)[] — Use event selectors to further specify the management and data event settings for your trail.

  By default, trails created without specific event selectors will be configured to log all read and write management events, and no data events. When an event occurs in your account, CloudTrail evaluates the event selector for all trails. For each trail, if the event matches any event selector, the trail processes and logs the event. If the event doesn't match any event selector, the trail doesn't log the event.

  You can configure up to five event selectors for a trail.

  You cannot apply both event selectors and advanced event selectors to a trail.

- `includeGlobalServiceEvents`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — Specifies whether the trail is publishing events from global services such as IAM to the log files.

- `insightSelectors`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnTrail.InsightSelectorProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_cloudtrail.CfnTrail.InsightSelectorProperty.html)[] — A JSON string that contains the Insights types you want to log on a trail.

  `ApiCallRateInsight` and `ApiErrorRateInsight` are valid Insight types.

  The `ApiCallRateInsight` Insights type analyzes write-only management API calls that are aggregated per minute against a baseline API call volume.

  The `ApiErrorRateInsight` Insights type analyzes management API calls that result in error codes. The error is shown if the API call is unsuccessful.

- `isLogging`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) (required) — Whether the CloudTrail trail is currently logging AWS API calls.

- `isMultiRegionTrail`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — Specifies whether the trail applies only to the current Region or to all Regions.

  The default is false. If the trail exists only in the current Region and this value is set to true, shadow trails (replications of the trail) will be created in the other Regions. If the trail exists in all Regions and this value is set to false, the trail will remain in the Region where it was created, and its shadow trails in other Regions will be deleted. As a best practice, consider using trails that log events in all Regions.

- `isOrganizationTrail`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — Specifies whether the trail is applied to all accounts in an organization in AWS Organizations , or only for the current AWS account .

  The default is false, and cannot be true unless the call is made on behalf of an AWS account that is the management account for an organization in AWS Organizations . If the trail is not an organization trail and this is set to `true` , the trail will be created in all AWS accounts that belong to the organization. If the trail is an organization trail and this is set to `false` , the trail will remain in the current AWS account but be deleted from all member accounts in the organization.

  > Only the management account for the organization can convert an organization trail to a non-organization trail, or convert a non-organization trail to an organization trail.

- `kmsKeyId`: string | [IAliasRef](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_kms.IAliasRef.html) | [IKeyRef](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_kms.IKeyRef.html) — Specifies the AWS key ID to use to encrypt the logs and digest files delivered by CloudTrail.

  The value can be an alias name prefixed by "alias/", a fully specified ARN to an alias, a fully specified ARN to a key, or a globally unique identifier.

  CloudTrail also supports AWS  multi-Region keys. For more information about multi-Region keys, see [Using multi-Region keys](https://docs.aws.amazon.com/kms/latest/developerguide/multi-region-keys-overview.html) in the *AWS Key Management Service Developer Guide* .

  Examples:

  - alias/MyAliasName
  - arn:aws:kms:us-east-2:123456789012:alias/MyAliasName
  - arn:aws:kms:us-east-2:123456789012:key/12345678-1234-1234-1234-123456789012
  - 12345678-1234-1234-1234-123456789012

- `s3BucketName`: string | [IBucketRef](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_s3.IBucketRef.html) (required) — Specifies the name of the Amazon S3 bucket designated for publishing log files.

  See [Amazon S3 Bucket naming rules](https://docs.aws.amazon.com/AmazonS3/latest/userguide/bucketnamingrules.html) .

- `s3KeyPrefix`: string — Specifies the Amazon S3 key prefix that comes after the name of the bucket you have designated for log file delivery.

  For more information, see [Finding Your CloudTrail Log Files](https://docs.aws.amazon.com/awscloudtrail/latest/userguide/get-and-view-cloudtrail-log-files.html#cloudtrail-find-log-files) . The maximum length is 200 characters.

- `snsTopicName`: string — Specifies the name or ARN of the Amazon SNS topic defined for notification of log file delivery.

  The maximum length is 256 characters.

- `tags`: [CfnTag](/cdk/api/v2/docs/aws-cdk-lib.CfnTag.html)[] — A custom set of tags (key-value pairs) for this trail.

- `trailName`: string — Specifies the name of the trail. The name must meet the following requirements:.

  - Contain only ASCII letters (a-z, A-Z), numbers (0-9), periods (.), underscores (_), or dashes (-)
  - Start with a letter or number, and end with a letter or number
  - Be between 3 and 128 characters
  - Have no adjacent periods, underscores or dashes. Names like `my-_namespace` and `my--namespace` are not valid.
  - Not be in IP address format (for example, 192.168.5.4)

## Properties

- `advancedEventSelectors`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnTrail.AdvancedEventSelectorProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_cloudtrail.CfnTrail.AdvancedEventSelectorProperty.html)[] — Specifies the settings for advanced event selectors.

- `aggregationConfigurations`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnTrail.AggregationConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_cloudtrail.CfnTrail.AggregationConfigurationProperty.html)[] — Specifies the aggregation configuration to aggregate CloudTrail Events.

- `attrArn`: string — `Ref` returns the ARN of the CloudTrail trail, such as `arn:aws:cloudtrail:us-east-2:123456789012:trail/myCloudTrail` .

- `attrSnsTopicArn`: string — `Ref` returns the ARN of the Amazon topic that's associated with the CloudTrail trail, such as `arn:aws:sns:us-east-2:123456789012:mySNSTopic` .

- `CFN_RESOURCE_TYPE_NAME`: string (static) — The CloudFormation resource type name for this resource class.

- `cfnOptions`: [ICfnResourceOptions](/cdk/api/v2/docs/aws-cdk-lib.ICfnResourceOptions.html) — Options for this resource, such as condition, update policy etc.

- `cfnResourceType`: string — AWS resource type.

- `cloudWatchLogsLogGroupArn`: string — Specifies a log group name using an Amazon Resource Name (ARN), a unique identifier that represents the log group to which CloudTrail logs are delivered.

- `cloudWatchLogsRoleArn`: string — Specifies the role for the CloudWatch Logs endpoint to assume to write to a user's log group.

- `creationStack`: string[]

- `enableLogFileValidation`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — Specifies whether log file validation is enabled.

  The default is false.

- `env`: [ResourceEnvironment](/cdk/api/v2/docs/aws-cdk-lib.interfaces.ResourceEnvironment.html)

- `eventSelectors`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnTrail.EventSelectorProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_cloudtrail.CfnTrail.EventSelectorProperty.html)[] — Use event selectors to further specify the management and data event settings for your trail.

- `includeGlobalServiceEvents`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — Specifies whether the trail is publishing events from global services such as IAM to the log files.

- `insightSelectors`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnTrail.InsightSelectorProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_cloudtrail.CfnTrail.InsightSelectorProperty.html)[] — A JSON string that contains the Insights types you want to log on a trail.

- `isLogging`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — Whether the CloudTrail trail is currently logging AWS API calls.

- `isMultiRegionTrail`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — Specifies whether the trail applies only to the current Region or to all Regions.

- `isOrganizationTrail`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — Specifies whether the trail is applied to all accounts in an organization in AWS Organizations , or only for the current AWS account .

- `kmsKeyId`: string — Specifies the AWS key ID to use to encrypt the logs and digest files delivered by CloudTrail.

- `logicalId`: string — The logical ID for this CloudFormation stack element.

  The logical ID of the element
  is calculated from the path of the resource node in the construct tree.

  To override this value, use `overrideLogicalId(newLogicalId)`.

- `node`: [Node](/cdk/api/v2/docs/constructs.Node.html) — The tree node.

- `ref`: string — Return a string that will be resolved to a CloudFormation `{ Ref }` for this element.

  If, by any chance, the intrinsic reference of a resource is not a string, you could
  coerce it to an IResolvable through `Lazy.any({ produce: resource.ref })`.

- `s3BucketName`: string — Specifies the name of the Amazon S3 bucket designated for publishing log files.

- `s3KeyPrefix`: string — Specifies the Amazon S3 key prefix that comes after the name of the bucket you have designated for log file delivery.

- `snsTopicName`: string — Specifies the name or ARN of the Amazon SNS topic defined for notification of log file delivery.

- `stack`: [Stack](/cdk/api/v2/docs/aws-cdk-lib.Stack.html) — The stack in which this element is defined.

  CfnElements must be defined within a stack scope (directly or indirectly).

- `tags`: [TagManager](/cdk/api/v2/docs/aws-cdk-lib.TagManager.html) — Tag Manager which manages the tags for this resource.

- `tagsRaw`: [CfnTag](/cdk/api/v2/docs/aws-cdk-lib.CfnTag.html)[] — A custom set of tags (key-value pairs) for this trail.

- `trailName`: string — Specifies the name of the trail.

  The name must meet the following requirements:.

- `trailRef`: [TrailReference](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_cloudtrail.TrailReference.html) — A reference to a Trail resource.

## Methods

- `addDeletionOverride(path: string): void` — Syntactic sugar for `addOverride(path, undefined)`.

  **Parameters**

  - `path` — The path of the value to delete.

- `addDependency(target: CfnResource): void` — Use `addResourceDependency` instead.

  This method has been renamed to `addResourceDependency` to more clearly
  set it apart from `construct.node.addDependency`. See the documentation
  of that function for more details.

- `addDependsOn(target: CfnResource): void` — Use `addResourceDependency` instead.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method has been renamed to `addResourceDependency`, which makes it
  more clear that this method operates at a different level from the
  construct-level `construct.node.addDependency()` mechanism.

- `addMetadata(key: string, value: any): void` — Add a value to the CloudFormation Resource Metadata.

- `addOverride(path: string, value: any): void` — Adds an override to the synthesized CloudFormation resource.

  To add a
  property override, either use `addPropertyOverride` or prefix `path` with
  "Properties." (i.e. `Properties.TopicName`).

  If the override is nested, separate each nested level using a dot (.) in the path parameter.
  If there is an array as part of the nesting, specify the index in the path.

  To include a literal `.` in the property name, prefix with a `\`. In most
  programming languages you will need to write this as `"\\."` because the
  `\` itself will need to be escaped.

  For example,
  ```typescript
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
  ```
  would add the overrides
  ```json
  "Properties": {
    "GlobalSecondaryIndexes": [
      {
        "Projection": {
          "NonKeyAttributes": [ "myattribute" ]
          ...
        }
        ...
      },
      {
        "ProjectionType": "INCLUDE"
        ...
      },
    ]
    ...
  }
  ```

  The `value` argument to `addOverride` will not be processed or translated
  in any way. Pass raw JSON values in here with the correct capitalization
  for CloudFormation. If you pass CDK classes or structs, they will be
  rendered with lowercased key names, and CloudFormation will reject the
  template.

  **Parameters**

  - `path` — - The path of the property, you can use dot notation to override values in complex types.
  - `value` — - The value.

- `addPropertyDeletionOverride(propertyPath: string): void` — Adds an override that deletes the value of a property from the resource definition.

  **Parameters**

  - `propertyPath` — The path to the property.

- `addPropertyOverride(propertyPath: string, value: any): void` — Adds an override to a resource property.

  Syntactic sugar for `addOverride("Properties.<...>", value)`.

  **Parameters**

  - `propertyPath` — The path of the property.
  - `value` — The value.

- `addResourceDependency(target: CfnResource, reason?: string): void` — Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method only adds dependencies between L1 resources. If you are
  looking for a generic construct-to-construct dependency mechanism that works
  for all constructs including L2s, use `construct.node.addDependency` instead.

- `applyCrossStackReferenceStrength(strength: ReferenceStrength): void` — Sets the cross-stack reference strength for this resource.

  When set, any cross-stack reference to this resource will use the specified
  strength instead of the global default from the consuming stack's context.

  **Parameters**

  - `strength` — - The reference strength to use for this resource.

- `applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): void` — Sets the deletion policy of the resource based on the removal policy specified.

  The Removal Policy controls what happens to this resource when it stops
  being managed by CloudFormation, either because you've removed it from the
  CDK application or because you've made a change that requires the resource
  to be replaced.

  The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
  account for data recovery and cleanup later (`RemovalPolicy.RETAIN`). In some
  cases, a snapshot can be taken of the resource prior to deletion
  (`RemovalPolicy.SNAPSHOT`). A list of resources that support this policy
  can be found in the following link:

- `arnForTrail(resource: ITrailRef): string` (static)

- `cfnPropertyName(cdkPropertyName: string): string`

- `fromTrailArn(scope: Construct, id: string, arn: string): ITrailRef` (static) — Creates a new ITrailRef from an ARN.

- `fromTrailName(scope: Construct, id: string, trailName: string): ITrailRef` (static) — Creates a new ITrailRef from a trailName.

- `getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Reference` — Returns a token for an runtime attribute of this resource.

  Ideally, use generated attribute accessors (e.g. `resource.arn`), but this can be used for future compatibility
  in case there is no generated attribute.

  **Parameters**

  - `attributeName` — The name of the attribute.

- `getMetadata(key: string): any` — Retrieve a value value from the CloudFormation Resource Metadata.

- `inspect(inspector: TreeInspector): void` — Examines the CloudFormation resource and discloses attributes.

  **Parameters**

  - `inspector` — tree inspector to collect and process attributes.

- `isCfnElement(x: any): boolean` (static) — Returns `true` if a construct is a stack element (i.e. part of the synthesized cloudformation template).

  Uses duck-typing instead of `instanceof` to allow stack elements from different
  versions of this library to be included in the same stack.

  **Returns:** The construct as a stack element or undefined if it is not a stack element.

- `isCfnResource(x: any): boolean` (static) — Check whether the given object is a CfnResource.

- `isCfnTrail(x: any): boolean` (static) — Checks whether the given object is a CfnTrail.

- `isConstruct(x: any): boolean` (static) — Checks if `x` is a construct.

  Use this method instead of `instanceof` to properly detect `Construct`
  instances, even when the construct library is symlinked.

  Explanation: in JavaScript, multiple copies of the `constructs` library on
  disk are seen as independent, completely different libraries. As a
  consequence, the class `Construct` in each copy of the `constructs` library
  is seen as a different class, and an instance of one class will not test as
  `instanceof` the other class. `npm install` will not create installations
  like this, but users may manually symlink construct libraries together or
  use a monorepo tool: in those cases, multiple copies of the `constructs`
  library can be accidentally installed, and `instanceof` will behave
  unpredictably. It is safest to avoid using `instanceof`, and using
  this type-testing method instead.

  **Parameters**

  - `x` — Any object.

  **Returns:** true if `x` is an object created from a class which extends `Construct`.

- `obtainDependencies(): Stack | CfnResource[]` — Retrieves an array of resources and stacks this resource depends on.

  For resources depended on directly, returns the `CfnResource` object. For
  dependencies on other stacks, returns the `Stack` object. The order of the
  array is not guaranteed.

- `overrideLogicalId(newLogicalId: string): void` — Overrides the auto-generated logical ID with a specific ID.

  **Parameters**

  - `newLogicalId` — The new logical ID to use for this stack element.

- `removeDependency(target: CfnResource): void` — Use `removeResourceDependency` instead

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `removeResourceDependency(target: CfnResource): void` — Indicates that this resource no longer depends on another resource.

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `replaceDependency(target: CfnResource, newTarget: CfnResource): void` — Replaces one dependency with another.

  **Parameters**

  - `target` — The dependency to replace.
  - `newTarget` — The new dependency to add.

- `toString(): string` — Returns a string representation of this construct.

  **Returns:** a string representation of this resource

- `with(...mixins: IMixin[]): IConstruct` — Applies one or more mixins to this construct.

  Mixins are applied in order. The list of constructs is captured at the
  start of the call, so constructs added by a mixin will not be visited.
  Use multiple `with()` calls if subsequent mixins should apply to added
  constructs.
